// 004 u_11_set_of_char
// 10 dec 2010

// -- (C) John COLIBRI 2010
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_11_set_of_char;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Panel4: TPanel;
    Memo1: TMemo;
    RichEdit1: TRichEdit;
    ListBox1: TListBox;
    Panel5: TPanel;
    Panel6: TPanel;
    Edit1: TEdit;
    Memo2: TMemo;
    set_of_char_: TButton;
    char_in_set_: TButton;
    Splitter2: TSplitter;
    convert_cyrillic_: TButton;
    ansichar_casting_: TButton;
    euro_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure set_of_char_Click(Sender: TObject);
    procedure char_in_set_Click(Sender: TObject);
    procedure euro_Click(Sender: TObject);
    procedure convert_cyrillic_Click(Sender: TObject);
    procedure ansichar_casting_Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
  uses Character, u_display_unicode;

{$R *.dfm}

    procedure display(p_text: String);
      begin
        Form1.Memo1.Lines.Add(p_text);
      end; // display

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure do_display(p_string: String);
      var l_index: Integer;
      begin
        with Form1 do
        begin
          ListBox1.Items.Add(p_string);
          RichEdit1.Text:= RichEdit1.Text+ p_string;
          Memo2.Lines.Add(p_string);
          Edit1.Text:= Edit1.Text+ p_string;

          display(f_display_unicode_string(p_string));
          for l_index:= 1 to Length(p_string) do
            display(Format('%2d ', [l_index])+ p_string[l_index]);
        end; // with Form1
      end; // do_display

    procedure do_display_ansi_string(p_ansi_string: AnsiString);
      var l_index: Integer;
      begin
        with Form1 do
        begin
          ListBox1.Items.Add(p_ansi_string);
          RichEdit1.Text:= RichEdit1.Text+ p_ansi_string;
          Memo2.Lines.Add(p_ansi_string);
          Edit1.Text:= Edit1.Text+ p_ansi_string;

          display(f_display_ansi_string(p_ansi_string));
          for l_index:= 1 to Length(p_ansi_string) do
            display(Format('%2d %1x ', [l_index, Ord(p_ansi_string[l_index])])+ p_ansi_string[l_index]);
        end; // with Form1
      end; // do_display_ansi_string

    procedure TForm1.set_of_char_Click(Sender: TObject);
      type t_set_of_ansi_char= Set of AnsiChar;

      procedure check(p_text: String; p_char: Char; p_ansi_char: AnsiChar; p_set_of_ansi_char: t_set_of_ansi_char);
        var l_result: String;
        begin
          if p_char in p_set_of_ansi_char
            then l_result:= ' ok'
            else l_result:= ' no';

          l_result:= Format('%-15s  $%4x   %2x ', [p_text, Word(p_char), Byte(p_ansi_Char)])+ l_result;
          display(l_result);
        end; // check

      begin // ansistring_Click
        check('A in [''A'', ''B'']', 'A', 'A', ['A', 'B']);
        check(' in ['''']', '', '', ['']);
        check(' in ['''']', '', '', ['']);
      end; // ansistring_Click

    procedure TForm1.char_in_set_Click(Sender: TObject);

      procedure check(p_text: String; p_result: Boolean);
        var l_result: String;
        begin
          if p_result
            then l_result:= ' OK'
            else l_result:= ' NO';
          display(Format('%-30s ', [p_text])+ l_result);
        end; // check

      var l_char: Char;
          l_ansi_char: AnsiChar;
          l_string: String;
          l_ansi_string: AnsiString;

      begin // char_in_set_Click
        check('CharInSet('''', [''''])', CharInSet('', ['']));
        check('l_char:= ''; ''CharInSet(l_char, [''''])', CharInSet(l_char, ['']));

        l_ansi_char:= AnsiChar(l_char);
        check('l_ansi_char:= AnsiChar(l_char); ''CharInSet(l_ansi_char, [''''])',
            CharInSet(l_ansi_char, ['']));

        l_string:= '';
        l_ansi_string:= l_string;
        check('l_string:= ''''; l_ansi_string:= l_string; ''CharInSet(l_ansi_string[1], [''''])',
            CharInSet(l_ansi_string[1], ['']));
      end; // generate_cyrillic_Click

    procedure TForm1.ansichar_casting_Click(Sender: TObject);
      var l_char: Char;
          l_ansi_char: AnsiChar;
      begin
        l_char:= '';
        l_ansi_char:= AnsiChar(l_char);
        display(Format('$%4x   %2x ', [Word(l_char), Byte(l_ansi_Char)]));
      end; // ansichar_casting_Click

    procedure TForm1.convert_cyrillic_Click(Sender: TObject);
      begin
      end; // convert_cyrillic_Click

    procedure TForm1.euro_Click(Sender: TObject);
      begin
      end; // euro_Click

    end.

